#include "mbed.h"
 
SPI spi(p5, p6, p7); // mosi, miso, sclk
Serial pc(USBTX, USBRX);

//DigitalOut slct01(p11);
//DigitalOut slct02(p12);
//DigitalOut slct03(p13);
//DigitalOut slct04(p14);
DigitalOut myled[] = {
    DigitalOut( LED1 ),  //  配列の1番目の要素をLED4で初期化したDigitalOutに
    DigitalOut( LED2 ),  //  ..
    DigitalOut( LED3 ),  //  ..
    DigitalOut( LED4 )   //  ..
};

DigitalOut  slct[]  = {  //  配列を用意します
    DigitalOut( p11 ),  //  配列の1番目の要素をLED4で初期化したDigitalOutに
    DigitalOut( p12 ),  //  ..
    DigitalOut( p13 ),  //  ..
    DigitalOut( p14 )   //  ..
};
 
 DigitalOut ExpaIO_reset(p21);
void SPIwrite_func(int cs, int value);


/**** グローバル変数 ****/
int Opcode = 0x40; //デフォ     charでいいのか？
char writeOpcode, readOpcode;
int i = 0;

//enum Port { PORT_A, PORT_B };

/**** マクロ定義 ****/
#define IODIRA   0x00
#define IODIRB   0x01
#define GPINTENA 0x04
#define DEFVALA  0x06
#define INTCONA  0x08
#define IOCON    0x0A
#define GPPUA    0x0C
#define GPIOA    0x12
#define GPIOB    0x13
#define OLATA    0x14
#define OLATB    0x15

#define PORT_A    0x00
#define PORT_B    0x01

#define CS_ALL_ON 0xF1


//1111 1000


// Control settings
//#define IOCON_BANK  0x80 // Banked registers
#define IOCON_BYTE_MODE 0x20 // Disables sequential operation. If bank = 0, operations toggle between A and B registers
#define IOCON_HAEN  0x08 // Hardware address enable

void init(void);
void write(int address, int data, int ch);

Timer t;
Timer t2;

int main() {
    wait(0.5);  //起動待ち処理
    
    myled[0] = 1;
    
    init();
    myled[1] = 1;
    
    int i = 0;
    int Mode;
    
    wait(1);    //念のためもう一回
    
    myled[0] = myled[1] = 0;
    
    while(1){//expanderの動作チェック
            myled[2] = 1;
            wait_us(50);
            
            Mode = 0xFF;
            
            t.start();
            
            for(i = 0; i < 4; i++){
                
                if(i == 3){
                     write(OLATA, Mode and CS_ALL_ON, i);    
                }
                else write(OLATA, Mode, i);
                
                wait_us(5);
            }
            
            pc.printf("Command 1A:'%d' '%d' '%d' \r\n", Opcode, OLATA, Mode);
            
            for(i = 0; i < 4; i++){
                write(OLATB, Mode, i);
                wait_us(5);
            }
            
            t.stop();
            
            pc.printf("Command 1B:'%d' '%d' '%d' \r\n", Opcode, OLATB, Mode);
            pc.printf("send time1:%.5f \r\n", t.read());
            
            t.reset();
            
            myled[2] = 0;
            myled[3] = 1;
            wait_us(5);
            Mode = 0xAA;
            
            
            t2.start();
            
            for(i = 0; i < 4; i++){
                
                if(i == 3){
                     write(OLATA, Mode | CS_ALL_ON, i);    
                }
                else write(OLATA, Mode, i);
            }
            
            pc.printf("Command 2A:'%d' '%d' '%d' \r\n", Opcode, OLATA, Mode);
            
            for(i = 0; i < 4; i++){
                write(OLATB, Mode, i);
            }
            
            
            t2.stop();
            wait_us(5);
            
            pc.printf("Command 2B:'%d' '%d' '%d' \r\n", Opcode, OLATB, Mode);
            pc.printf("send time2:%.5f \r\n", t2.read());
            
            t2.reset();
            
            myled[3] = 0;
            wait_us(1);
            
//            printf("\033[2J");          //teratermの画面クリア
//            printf("\033[1;1H");        //teratermの画面クリア
    }
    
    // Select the device by seting chip select low
//    cs = 0;

//    // Send 0x8f, the command to read the WHOAMI register
//    spi.write(0xff);
 
    // Send a dummy byte to receive the contents of the WHOAMI register
    //int whoami = spi.write(0x00);
//    printf("WHOAMI register = 0x%X\n", whoami);
 
    // Deselect the device
//    cs = 1;
}


void init(void){
    
    // Setup the spi for 8 bit data, high steady state clock,
    // second edge capture, with a 10MHz clock rate
    spi.format(8,3);
    spi.frequency(1000000);
    
    pc.baud(115200);
    
    //現状，おまじない
    writeOpcode = Opcode;
    readOpcode = writeOpcode | 1; // low order bit = 1 for read    
    
    /* エキスパンダのリセット */
    ExpaIO_reset = 0;   //Lowでreset発動
    wait_ms(1);
    ExpaIO_reset = 1;   //Highでresetターンオフ
    wait_ms(1);
    
    slct[0] = slct[1] = slct[2] = slct[3] = 1;
       
    /* コントロールレジスタの(IOCON)の設定 */
    for(i = 0; i < 4; i++){
        //コントロールレジスタの操作
        write(IOCON, (IOCON_BYTE_MODE | IOCON_HAEN ), i); // Hardware addressing on, operations toggle between A and B registers
        //wait_us(1);   //おまじない
    }
    
    /* LATレジスタ初期化 参考より */
    for(i = 0; i < 4; i++){
        write(OLATA, 0x00, i);   //Aポートを出力として設定
        //wait_us(1);   //おまじない
        write(OLATB, 0x00, i);   //Bポートを出力として設定
        //wait_us(1);   //おまじない
    }

    
    /* ポートの入出力設定 */
    //OLATAに0か1をビット可算することによってOLATAとOLATBにしてた
    //data sheetのSPIの所には16進のアドレスがどこに来るかが書かれていない...
    for(i = 0; i < 4; i++){
        write(IODIRA, 0x00, i);   //Aポートを出力として設定
        //wait_us(1);   //おまじない
        write(IODIRB, 0x00, i);   //Bポートを出力として設定
        //wait_us(1);   //おまじない
    }
}

void write(int address, int data, int ch) {
    slct[ch] = 0;   //セレクタオープン
    //wait_us(1);
    spi.write(Opcode);  //Device opcode,コントロールバイトの記述
    spi.write(address);
    spi.write(data);
    slct[ch] = 1;   //セレクタクローズ
    //wait_us(1);
}